# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    def swig_import_helper():
        import importlib
        pkg = __name__.rpartition('.')[0]
        mname = '.'.join((pkg, '_bispectrumintegrator')).lstrip('.')
        try:
            return importlib.import_module(mname)
        except ImportError:
            return importlib.import_module('_bispectrumintegrator')
    _bispectrumintegrator = swig_import_helper()
    del swig_import_helper
elif _swig_python_version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_bispectrumintegrator', [dirname(__file__)])
        except ImportError:
            import _bispectrumintegrator
            return _bispectrumintegrator
        try:
            _mod = imp.load_module('_bispectrumintegrator', fp, pathname, description)
        finally:
            if fp is not None:
                fp.close()
        return _mod
    _bispectrumintegrator = swig_import_helper()
    del swig_import_helper
else:
    import _bispectrumintegrator
del _swig_python_version_info

try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

try:
    import weakref
    weakref_proxy = weakref.proxy
except __builtin__.Exception:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _bispectrumintegrator.delete_SwigPyIterator
    __del__ = lambda self: None

    def value(self) -> "PyObject *":
        return _bispectrumintegrator.SwigPyIterator_value(self)

    def incr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        return _bispectrumintegrator.SwigPyIterator_incr(self, n)

    def decr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        return _bispectrumintegrator.SwigPyIterator_decr(self, n)

    def distance(self, x: 'SwigPyIterator') -> "ptrdiff_t":
        return _bispectrumintegrator.SwigPyIterator_distance(self, x)

    def equal(self, x: 'SwigPyIterator') -> "bool":
        return _bispectrumintegrator.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _bispectrumintegrator.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _bispectrumintegrator.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _bispectrumintegrator.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _bispectrumintegrator.SwigPyIterator_previous(self)

    def advance(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        return _bispectrumintegrator.SwigPyIterator_advance(self, n)

    def __eq__(self, x: 'SwigPyIterator') -> "bool":
        return _bispectrumintegrator.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: 'SwigPyIterator') -> "bool":
        return _bispectrumintegrator.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        return _bispectrumintegrator.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        return _bispectrumintegrator.SwigPyIterator___isub__(self, n)

    def __add__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        return _bispectrumintegrator.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _bispectrumintegrator.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self
SwigPyIterator_swigregister = _bispectrumintegrator.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

SHARED_PTR_DISOWN = _bispectrumintegrator.SHARED_PTR_DISOWN
import CosmoBolognaLib
class bispectrum_integral_inputs(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, bispectrum_integral_inputs, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, bispectrum_integral_inputs, name)
    __repr__ = _swig_repr
    __swig_setmethods__["integrand"] = _bispectrumintegrator.bispectrum_integral_inputs_integrand_set
    __swig_getmethods__["integrand"] = _bispectrumintegrator.bispectrum_integral_inputs_integrand_get
    if _newclass:
        integrand = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_integrand_get, _bispectrumintegrator.bispectrum_integral_inputs_integrand_set)
    __swig_setmethods__["qmin"] = _bispectrumintegrator.bispectrum_integral_inputs_qmin_set
    __swig_getmethods__["qmin"] = _bispectrumintegrator.bispectrum_integral_inputs_qmin_get
    if _newclass:
        qmin = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_qmin_get, _bispectrumintegrator.bispectrum_integral_inputs_qmin_set)
    __swig_setmethods__["qmax"] = _bispectrumintegrator.bispectrum_integral_inputs_qmax_set
    __swig_getmethods__["qmax"] = _bispectrumintegrator.bispectrum_integral_inputs_qmax_get
    if _newclass:
        qmax = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_qmax_get, _bispectrumintegrator.bispectrum_integral_inputs_qmax_set)
    __swig_setmethods__["log_qmin"] = _bispectrumintegrator.bispectrum_integral_inputs_log_qmin_set
    __swig_getmethods__["log_qmin"] = _bispectrumintegrator.bispectrum_integral_inputs_log_qmin_get
    if _newclass:
        log_qmin = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_log_qmin_get, _bispectrumintegrator.bispectrum_integral_inputs_log_qmin_set)
    __swig_setmethods__["log_qmax"] = _bispectrumintegrator.bispectrum_integral_inputs_log_qmax_set
    __swig_getmethods__["log_qmax"] = _bispectrumintegrator.bispectrum_integral_inputs_log_qmax_get
    if _newclass:
        log_qmax = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_log_qmax_get, _bispectrumintegrator.bispectrum_integral_inputs_log_qmax_set)
    __swig_setmethods__["k1"] = _bispectrumintegrator.bispectrum_integral_inputs_k1_set
    __swig_getmethods__["k1"] = _bispectrumintegrator.bispectrum_integral_inputs_k1_get
    if _newclass:
        k1 = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_k1_get, _bispectrumintegrator.bispectrum_integral_inputs_k1_set)
    __swig_setmethods__["k2"] = _bispectrumintegrator.bispectrum_integral_inputs_k2_set
    __swig_getmethods__["k2"] = _bispectrumintegrator.bispectrum_integral_inputs_k2_get
    if _newclass:
        k2 = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_k2_get, _bispectrumintegrator.bispectrum_integral_inputs_k2_set)
    __swig_setmethods__["k3"] = _bispectrumintegrator.bispectrum_integral_inputs_k3_set
    __swig_getmethods__["k3"] = _bispectrumintegrator.bispectrum_integral_inputs_k3_get
    if _newclass:
        k3 = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_k3_get, _bispectrumintegrator.bispectrum_integral_inputs_k3_set)
    __swig_setmethods__["force_range"] = _bispectrumintegrator.bispectrum_integral_inputs_force_range_set
    __swig_getmethods__["force_range"] = _bispectrumintegrator.bispectrum_integral_inputs_force_range_get
    if _newclass:
        force_range = _swig_property(_bispectrumintegrator.bispectrum_integral_inputs_force_range_get, _bispectrumintegrator.bispectrum_integral_inputs_force_range_set)

    def __init__(self):
        this = _bispectrumintegrator.new_bispectrum_integral_inputs()
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _bispectrumintegrator.delete_bispectrum_integral_inputs
    __del__ = lambda self: None
bispectrum_integral_inputs_swigregister = _bispectrumintegrator.bispectrum_integral_inputs_swigregister
bispectrum_integral_inputs_swigregister(bispectrum_integral_inputs)

class IntegrationResult(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntegrationResult, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntegrationResult, name)
    __repr__ = _swig_repr
    __swig_setmethods__["Int"] = _bispectrumintegrator.IntegrationResult_Int_set
    __swig_getmethods__["Int"] = _bispectrumintegrator.IntegrationResult_Int_get
    if _newclass:
        Int = _swig_property(_bispectrumintegrator.IntegrationResult_Int_get, _bispectrumintegrator.IntegrationResult_Int_set)
    __swig_setmethods__["nEvals"] = _bispectrumintegrator.IntegrationResult_nEvals_set
    __swig_getmethods__["nEvals"] = _bispectrumintegrator.IntegrationResult_nEvals_get
    if _newclass:
        nEvals = _swig_property(_bispectrumintegrator.IntegrationResult_nEvals_get, _bispectrumintegrator.IntegrationResult_nEvals_set)
    __swig_setmethods__["error"] = _bispectrumintegrator.IntegrationResult_error_set
    __swig_getmethods__["error"] = _bispectrumintegrator.IntegrationResult_error_get
    if _newclass:
        error = _swig_property(_bispectrumintegrator.IntegrationResult_error_get, _bispectrumintegrator.IntegrationResult_error_set)
    __swig_setmethods__["status"] = _bispectrumintegrator.IntegrationResult_status_set
    __swig_getmethods__["status"] = _bispectrumintegrator.IntegrationResult_status_get
    if _newclass:
        status = _swig_property(_bispectrumintegrator.IntegrationResult_status_get, _bispectrumintegrator.IntegrationResult_status_set)

    def __init__(self):
        this = _bispectrumintegrator.new_IntegrationResult()
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _bispectrumintegrator.delete_IntegrationResult
    __del__ = lambda self: None
IntegrationResult_swigregister = _bispectrumintegrator.IntegrationResult_swigregister
IntegrationResult_swigregister(IntegrationResult)


def kernel_b222_(_kernel: 'double *', _q: 'double const *', _p: 'double const *', _phi: 'double const *', _k1: 'double const *', _k2: 'double const *', _k3: 'double const *') -> "void":
    return _bispectrumintegrator.kernel_b222_(_kernel, _q, _p, _phi, _k1, _k2, _k3)
kernel_b222_ = _bispectrumintegrator.kernel_b222_

def kernel_b321_i_(_kernel: 'double *', _q: 'double const *', _p: 'double const *', _k3: 'double const *', _k1: 'double const *', _k2: 'double const *') -> "void":
    return _bispectrumintegrator.kernel_b321_i_(_kernel, _q, _p, _k3, _k1, _k2)
kernel_b321_i_ = _bispectrumintegrator.kernel_b321_i_

def kernel_b321_ii_(_kernel: 'double *', _q: 'double const *', _k1: 'double const *', _k2: 'double const *', _k3: 'double const *') -> "void":
    return _bispectrumintegrator.kernel_b321_ii_(_kernel, _q, _k1, _k2, _k3)
kernel_b321_ii_ = _bispectrumintegrator.kernel_b321_ii_

def kernel_b411_(_kernel: 'double *', _qq: 'double const *', _kk1: 'double const *', _kk2: 'double const *', _kk3: 'double const *') -> "void":
    return _bispectrumintegrator.kernel_b411_(_kernel, _qq, _kk1, _kk2, _kk3)
kernel_b411_ = _bispectrumintegrator.kernel_b411_

def kernel_b411_old_(_kernel: 'double *', _q: 'double const *', _k1: 'double const *', _k2: 'double const *', _k3: 'double const *') -> "void":
    return _bispectrumintegrator.kernel_b411_old_(_kernel, _q, _k1, _k2, _k3)
kernel_b411_old_ = _bispectrumintegrator.kernel_b411_old_

def kernel_B222(q: 'double const &', p: 'double const &', phi: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &') -> "double":
    return _bispectrumintegrator.kernel_B222(q, p, phi, k1, k2, k3)
kernel_B222 = _bispectrumintegrator.kernel_B222

def kernel_B321_I(q: 'double const &', p: 'double const &', k3: 'double const &', k1: 'double const &', k2: 'double const &') -> "double":
    return _bispectrumintegrator.kernel_B321_I(q, p, k3, k1, k2)
kernel_B321_I = _bispectrumintegrator.kernel_B321_I

def kernel_B321_II(q: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &') -> "double":
    return _bispectrumintegrator.kernel_B321_II(q, k1, k2, k3)
kernel_B321_II = _bispectrumintegrator.kernel_B321_II

def kernel_B411(q: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &') -> "double":
    return _bispectrumintegrator.kernel_B411(q, k1, k2, k3)
kernel_B411 = _bispectrumintegrator.kernel_B411

def kernel_B411_old(q: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &') -> "double":
    return _bispectrumintegrator.kernel_B411_old(q, k1, k2, k3)
kernel_B411_old = _bispectrumintegrator.kernel_B411_old

def integrand_B222(q: 'double const &', p: 'double const &', phi: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid', qmin: 'double const &', qmax: 'double const &') -> "double":
    return _bispectrumintegrator.integrand_B222(q, p, phi, k1, k2, k3, interp_Pk, qmin, qmax)
integrand_B222 = _bispectrumintegrator.integrand_B222

def CUBA_integrand_B222(ndim: 'int const *', xx: 'cubareal const []', ncomp: 'int const *', ff: 'cubareal []', userdata: 'void *') -> "int":
    return _bispectrumintegrator.CUBA_integrand_B222(ndim, xx, ncomp, ff, userdata)
CUBA_integrand_B222 = _bispectrumintegrator.CUBA_integrand_B222

def integrand_B321_I(q: 'double const &', p: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid') -> "double":
    return _bispectrumintegrator.integrand_B321_I(q, p, k1, k2, k3, interp_Pk)
integrand_B321_I = _bispectrumintegrator.integrand_B321_I

def CUBA_integrand_B321_I(ndim: 'int const *', xx: 'cubareal const []', ncomp: 'int const *', ff: 'cubareal []', userdata: 'void *') -> "int":
    return _bispectrumintegrator.CUBA_integrand_B321_I(ndim, xx, ncomp, ff, userdata)
CUBA_integrand_B321_I = _bispectrumintegrator.CUBA_integrand_B321_I

def integrand_B321_II(q: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid') -> "double":
    return _bispectrumintegrator.integrand_B321_II(q, k1, k2, k3, interp_Pk)
integrand_B321_II = _bispectrumintegrator.integrand_B321_II

def integrand_B411(q: 'double const &', k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid') -> "double":
    return _bispectrumintegrator.integrand_B411(q, k1, k2, k3, interp_Pk)
integrand_B411 = _bispectrumintegrator.integrand_B411

def integrate_1D(integrand: 'cbl::FunctionDoubleDouble', a: 'double const', b: 'double const', rel_err: 'double const', abs_err: 'double const', nsub: 'size_t const') -> "sptintegration::IntegrationResult":
    return _bispectrumintegrator.integrate_1D(integrand, a, b, rel_err, abs_err, nsub)
integrate_1D = _bispectrumintegrator.integrate_1D

def integrate_B222(k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid', a: 'double const', b: 'double const', rel_err: 'double const', abs_err: 'double const', max_evals: 'size_t const', force_range: 'bool const') -> "sptintegration::IntegrationResult":
    return _bispectrumintegrator.integrate_B222(k1, k2, k3, interp_Pk, a, b, rel_err, abs_err, max_evals, force_range)
integrate_B222 = _bispectrumintegrator.integrate_B222

def integrate_B321_I(k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid', a: 'double const', b: 'double const', rel_err: 'double const', abs_err: 'double const', max_evals: 'size_t const', force_range: 'bool const') -> "sptintegration::IntegrationResult":
    return _bispectrumintegrator.integrate_B321_I(k1, k2, k3, interp_Pk, a, b, rel_err, abs_err, max_evals, force_range)
integrate_B321_I = _bispectrumintegrator.integrate_B321_I

def integrate_B321_II(k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid', a: 'double const', b: 'double const', rel_err: 'double const', abs_err: 'double const', nsub: 'size_t const') -> "sptintegration::IntegrationResult":
    return _bispectrumintegrator.integrate_B321_II(k1, k2, k3, interp_Pk, a, b, rel_err, abs_err, nsub)
integrate_B321_II = _bispectrumintegrator.integrate_B321_II

def integrate_B411(k1: 'double const &', k2: 'double const &', k3: 'double const &', interp_Pk: 'FuncGrid', a: 'double const', b: 'double const', rel_err: 'double const', abs_err: 'double const', nsub: 'size_t const') -> "sptintegration::IntegrationResult":
    return _bispectrumintegrator.integrate_B411(k1, k2, k3, interp_Pk, a, b, rel_err, abs_err, nsub)
integrate_B411 = _bispectrumintegrator.integrate_B411

def full_B222(*args) -> "std::vector< sptintegration::IntegrationResult,std::allocator< sptintegration::IntegrationResult > >":
    return _bispectrumintegrator.full_B222(*args)
full_B222 = _bispectrumintegrator.full_B222

def full_B321_I(*args) -> "std::vector< sptintegration::IntegrationResult,std::allocator< sptintegration::IntegrationResult > >":
    return _bispectrumintegrator.full_B321_I(*args)
full_B321_I = _bispectrumintegrator.full_B321_I

def full_B321_II(*args) -> "std::vector< sptintegration::IntegrationResult,std::allocator< sptintegration::IntegrationResult > >":
    return _bispectrumintegrator.full_B321_II(*args)
full_B321_II = _bispectrumintegrator.full_B321_II

def full_B411(*args) -> "std::vector< sptintegration::IntegrationResult,std::allocator< sptintegration::IntegrationResult > >":
    return _bispectrumintegrator.full_B411(*args)
full_B411 = _bispectrumintegrator.full_B411
class IntegrationResultsVector(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntegrationResultsVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntegrationResultsVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        return _bispectrumintegrator.IntegrationResultsVector_iterator(self)
    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        return _bispectrumintegrator.IntegrationResultsVector___nonzero__(self)

    def __bool__(self) -> "bool":
        return _bispectrumintegrator.IntegrationResultsVector___bool__(self)

    def __len__(self) -> "std::vector< sptintegration::IntegrationResult >::size_type":
        return _bispectrumintegrator.IntegrationResultsVector___len__(self)

    def __getslice__(self, i: 'std::vector< sptintegration::IntegrationResult >::difference_type', j: 'std::vector< sptintegration::IntegrationResult >::difference_type') -> "std::vector< sptintegration::IntegrationResult,std::allocator< sptintegration::IntegrationResult > > *":
        return _bispectrumintegrator.IntegrationResultsVector___getslice__(self, i, j)

    def __setslice__(self, *args) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector___setslice__(self, *args)

    def __delslice__(self, i: 'std::vector< sptintegration::IntegrationResult >::difference_type', j: 'std::vector< sptintegration::IntegrationResult >::difference_type') -> "void":
        return _bispectrumintegrator.IntegrationResultsVector___delslice__(self, i, j)

    def __delitem__(self, *args) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector___delitem__(self, *args)

    def __getitem__(self, *args) -> "std::vector< sptintegration::IntegrationResult >::value_type const &":
        return _bispectrumintegrator.IntegrationResultsVector___getitem__(self, *args)

    def __setitem__(self, *args) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector___setitem__(self, *args)

    def pop(self) -> "std::vector< sptintegration::IntegrationResult >::value_type":
        return _bispectrumintegrator.IntegrationResultsVector_pop(self)

    def append(self, x: 'IntegrationResult') -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_append(self, x)

    def empty(self) -> "bool":
        return _bispectrumintegrator.IntegrationResultsVector_empty(self)

    def size(self) -> "std::vector< sptintegration::IntegrationResult >::size_type":
        return _bispectrumintegrator.IntegrationResultsVector_size(self)

    def swap(self, v: 'IntegrationResultsVector') -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_swap(self, v)

    def begin(self) -> "std::vector< sptintegration::IntegrationResult >::iterator":
        return _bispectrumintegrator.IntegrationResultsVector_begin(self)

    def end(self) -> "std::vector< sptintegration::IntegrationResult >::iterator":
        return _bispectrumintegrator.IntegrationResultsVector_end(self)

    def rbegin(self) -> "std::vector< sptintegration::IntegrationResult >::reverse_iterator":
        return _bispectrumintegrator.IntegrationResultsVector_rbegin(self)

    def rend(self) -> "std::vector< sptintegration::IntegrationResult >::reverse_iterator":
        return _bispectrumintegrator.IntegrationResultsVector_rend(self)

    def clear(self) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_clear(self)

    def get_allocator(self) -> "std::vector< sptintegration::IntegrationResult >::allocator_type":
        return _bispectrumintegrator.IntegrationResultsVector_get_allocator(self)

    def pop_back(self) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_pop_back(self)

    def erase(self, *args) -> "std::vector< sptintegration::IntegrationResult >::iterator":
        return _bispectrumintegrator.IntegrationResultsVector_erase(self, *args)

    def __init__(self, *args):
        this = _bispectrumintegrator.new_IntegrationResultsVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'IntegrationResult') -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_push_back(self, x)

    def front(self) -> "std::vector< sptintegration::IntegrationResult >::value_type const &":
        return _bispectrumintegrator.IntegrationResultsVector_front(self)

    def back(self) -> "std::vector< sptintegration::IntegrationResult >::value_type const &":
        return _bispectrumintegrator.IntegrationResultsVector_back(self)

    def assign(self, n: 'std::vector< sptintegration::IntegrationResult >::size_type', x: 'IntegrationResult') -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_assign(self, n, x)

    def resize(self, *args) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_resize(self, *args)

    def insert(self, *args) -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_insert(self, *args)

    def reserve(self, n: 'std::vector< sptintegration::IntegrationResult >::size_type') -> "void":
        return _bispectrumintegrator.IntegrationResultsVector_reserve(self, n)

    def capacity(self) -> "std::vector< sptintegration::IntegrationResult >::size_type":
        return _bispectrumintegrator.IntegrationResultsVector_capacity(self)
    __swig_destroy__ = _bispectrumintegrator.delete_IntegrationResultsVector
    __del__ = lambda self: None
IntegrationResultsVector_swigregister = _bispectrumintegrator.IntegrationResultsVector_swigregister
IntegrationResultsVector_swigregister(IntegrationResultsVector)

# This file is compatible with both classic and new-style classes.


